void explode (data_val_t v, int *arr, int offset)
{
  int i;
  for (i=0; i<8; i++) {
    arr[i+offset] = is_bit_set (v, 8-1-i);
  }
}

data_val_t implode (int *arr, int offset)
{
  data_val_t v = 0;
  int i;

  for (i=0; i<8; i++) {
    if (arr[offset+i]) {
      v |= (1<<(8-1-i));
    }
  }

  return v;
}

void set_mem (struct memory *m, int addr, struct mem_loc_t val)
{
  m->core[addr] = val;
}

void mask_val (data_t *dest, data_t val, data_t mask)
{
  *dest = (*dest & ~mask) | (val & mask);
}

void mask_mem_loc (struct memory *m, 
		   data_addr_t addr, 
		   struct mem_loc_t x, 
		   data_t mask)
{
  mask_val(&m->core[addr].known,x.known, mask);
  mask_val(&m->core[addr].val,  x.val,   mask);
}

void set_cc (struct memory *m, 
	     struct mem_loc_t x, 
	     data_t mask)
{
  mask_mem_loc (m, io_to_mem (SREG_ADDR), x, mask);
}

void set_cc_nomask (struct memory *m, 
		    struct mem_loc_t x)
{
  m->core[io_to_mem (SREG_ADDR)] = x;
}

struct mem_loc_t get_cc (struct memory *m)
{
  return m->core[io_to_mem (SREG_ADDR)];
}

struct mem_loc_t get_mem (struct memory *m, int addr)
{
  return m->core[addr];
}

