#include "stacktool.h"
#include "bdd_bitbit_ldi.h"

struct mem_loc_t bdd_bitbit_ldi_res (struct mem_loc_t in1, data_val_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2, bdd_op_inputs, 2 * 8);
  explode (0xff, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = bdd_op_inputs[16];
  // bitbit_01_0_8.bdd
  outputs[1] = bdd_op_inputs[17];
  // bitbit_02_0_8.bdd
  outputs[2] = bdd_op_inputs[18];
  // bitbit_03_0_8.bdd
  outputs[3] = bdd_op_inputs[19];
  // bitbit_04_0_8.bdd
  outputs[4] = bdd_op_inputs[20];
  // bitbit_05_0_8.bdd
  outputs[5] = bdd_op_inputs[21];
  // bitbit_06_0_8.bdd
  outputs[6] = bdd_op_inputs[22];
  // bitbit_07_0_8.bdd
  outputs[7] = bdd_op_inputs[23];
  // bitbit_08_0_8.bdd
  outputs[8] = bdd_op_inputs[24];
  // bitbit_09_0_8.bdd
  outputs[9] = bdd_op_inputs[25];
  // bitbit_10_0_8.bdd
  outputs[10] = bdd_op_inputs[26];
  // bitbit_11_0_8.bdd
  outputs[11] = bdd_op_inputs[27];
  // bitbit_12_0_8.bdd
  outputs[12] = bdd_op_inputs[28];
  // bitbit_13_0_8.bdd
  outputs[13] = bdd_op_inputs[29];
  // bitbit_14_0_8.bdd
  outputs[14] = bdd_op_inputs[30];
  // bitbit_15_0_8.bdd
  outputs[15] = bdd_op_inputs[31];
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}

struct mem_loc_t bdd_bitbit_ldi_cc (struct mem_loc_t in1, data_val_t in2, struct mem_loc_t cc)
{
  explode (in1.val, bdd_op_inputs, 0 * 8);
  explode (in1.known, bdd_op_inputs, 1 * 8);
  explode (in2, bdd_op_inputs, 2 * 8);
  explode (0xff, bdd_op_inputs, 3 * 8);
  int outputs[2 * 8];

  struct mem_loc_t ret;
  int set = 0;
  int cc_value;
  for(cc_value=0; cc_value <= 0x0; ++cc_value) {
    if ((cc.val & cc.known & 0x0) != 
	(cc_value & cc.known & 0x0)) continue;
    if ((cc_value & ~0x0) != 0) continue;

    switch (cc_value) {
case 0:
  // bitbit_00_0_8.bdd
  outputs[0] = 0;
  // bitbit_01_0_8.bdd
  outputs[1] = 0;
  // bitbit_02_0_8.bdd
  outputs[2] = 0;
  // bitbit_03_0_8.bdd
  outputs[3] = 0;
  // bitbit_04_0_8.bdd
  outputs[4] = 0;
  // bitbit_05_0_8.bdd
  outputs[5] = 0;
  // bitbit_06_0_8.bdd
  outputs[6] = 0;
  // bitbit_07_0_8.bdd
  outputs[7] = 0;
  // bitbit_08_0_8.bdd
  outputs[8] = 1;
  // bitbit_09_0_8.bdd
  outputs[9] = 1;
  // bitbit_10_0_8.bdd
  outputs[10] = 1;
  // bitbit_11_0_8.bdd
  outputs[11] = 1;
  // bitbit_12_0_8.bdd
  outputs[12] = 1;
  // bitbit_13_0_8.bdd
  outputs[13] = 1;
  // bitbit_14_0_8.bdd
  outputs[14] = 1;
  // bitbit_15_0_8.bdd
  outputs[15] = 1;
  break;

  default: assert (0);
    }

    struct mem_loc_t r;
    r.val   = implode (outputs, 0 * 8);
    r.known = implode (outputs, 1 * 8);
    ret = set ? merge(r,ret) : r;
    set = 1;
  }
  assert(set);
  return ret;
}


#ifdef STACKTOOL
void bdd_bitbit_ldi (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 1
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  {
    struct mem_loc_t ccin = get_cc(m);
    struct mem_loc_t res = bdd_bitbit_ldi_res (get_mem (m, dst_reg), imm, ccin);
    struct mem_loc_t cc  = bdd_bitbit_ldi_cc  (get_mem (m, dst_reg), imm, ccin);
    set_mem (m, dst_reg, res);
    set_cc  (m, cc, 0x0);
  }
}
#endif

#ifdef STACKTOOL
void classic_bitbit_ldi (struct memory *m
	       ,int dst_reg 
#if (2==2)
#if 1
	       ,data_val_t imm
#else
	       ,int src_reg
#endif
#endif
               )
{
  struct decoder_info dec;
  dec.opcode = AVR_ldi;
#if (2==2)
#if 1
  dec.K = imm;
  dec.K_set = 1;  
#else
  dec.src_reg = src_reg;
  dec.src_reg_set = 1;
#endif
#endif
  dec.dst_reg = dst_reg;
  dec.dst_reg_set = 1;
  abstract_interp_insn (m, &dec);
}
#endif

